library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-------------------------------------------------------------------------------
-- This module implements a synchronous 1-bit register.
-------------------------------------------------------------------------------

  entity bit_reg is
    generic (
      DATA_WIDTH : integer);            -- width of register
    Port (
      clk    : in  std_logic;
      input  : in  std_logic_vector(DATA_WIDTH-1 downto 0);
      output : out std_logic_vector(DATA_WIDTH-1 downto 0)
      );
  end bit_reg;

  architecture bit_reg_arch of bit_reg is

  begin

    REGISTER_BIT: process(clk)
    begin
      if clk'event and clk = '1' then
        output <= input;                        -- since this is synchronous, a Flip-Flop is inferred
      end if;
    end process REGISTER_BIT;

  end bit_reg_arch;
